## dogtag-pki 11.0.0

=== themes/CMakeLists.txt ===
project(themes)

add_subdirectory(${THEME})

=== base/javadoc/CMakeLists.txt ===
project(pki-javadoc)

# It is important to identify the version of 'javadoc' being utilized since
# different versions support different options.
#
# While 'cmake' contains numerous built-in references to the 'java' version,
# it contains no built-in references to either the 'javac' or 'javadoc'
# versions, and unfortunately, the specified version of 'java' may be
# different from the specified versions of 'javac' and 'javadoc'.
#
# Additionally, although 'javadoc' contains no command-line option to identify
# its version, it is important to note that 'javadoc' is supplied by the same
# package that supplies 'javac', and although multiple versions of these
# executables could co-exist on the same system, it is relatively safe to
# assert that the currently specified 'javac' and 'javadoc' will be the same
# version.
#
# As an example in support of this assertion, on systems which utilize
# '/usr/sbin/alternatives', setting the 'javac' version will also
# automatically set the 'javadoc' version to match the 'javac' version, and
# 'usr/sbin/alternatives' cannot be used to set a specific 'javadoc' version.
#
# Therefore, regardless of the 'java' version, this 'CMakeLists.txt' file will
# programmatically utilize the invoked 'javac' version information (output is
# to stderr) in order to correctly identify the supported 'javadoc' options:
#
#     # javac -version 2>&1 | awk -F \. '{printf $2}'
#
# NOTE:  Used 'cut' instead of 'awk' due to 'cmake' parsing limitations:
#
#     # javac -version 2>&1 | cut -f2 -d.
#
message( STATUS "Java_VERSION_STRING = '${Java_VERSION_STRING}'" )
execute_process(
    COMMAND
        javac -version
    ERROR_VARIABLE
        Javac_VERSION_OUTPUT
    OUTPUT_VARIABLE
        Javac_VERSION_OUTPUT
    ERROR_STRIP_TRAILING_WHITESPACE
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
message( STATUS "Javac_VERSION_OUTPUT = '${Javac_VERSION_OUTPUT}'" )
string(REGEX REPLACE ".* ([0-9]+).*" "\\1" Javadoc_VERSION_MAJOR ${Javac_VERSION_OUTPUT})
message( STATUS "Javadoc_VERSION_MAJOR = '${Javadoc_VERSION_MAJOR}'" )
string(REGEX REPLACE ".* [0-9]+\\.([0-9]+).*" "\\1" Javadoc_VERSION_MINOR ${Javac_VERSION_OUTPUT})
message( STATUS "Javadoc_VERSION_MINOR = '${Javadoc_VERSION_MINOR}'" )

# REMINDER:  Eventually, it would almost certainly be safer to obtain the
#            'Javadoc_VERSION_MAJOR' number as well and perform the check
#            on "'Javadoc_VERSION_MAJOR'.'Javadoc_VERSION_MINOR'".
#
set(doclintstr "")
if(((${Javadoc_VERSION_MAJOR} EQUAL 1) AND (${Javadoc_VERSION_MINOR} EQUAL 8)) OR (${Javadoc_VERSION_MAJOR} GREATER 8))
    set(doclintstr "-Xdoclint:none")
endif()

javadoc(pki-javadoc
    SOURCEPATH
        ${CMAKE_SOURCE_DIR}/base/util/src/main/java
        ${CMAKE_SOURCE_DIR}/base/common/src/main/java
        ${CMAKE_SOURCE_DIR}/base/tools/src/main/java
        ${PKI_JAVADOC_SOURCEPATH}
    DEST
        ${CMAKE_CURRENT_BINARY_DIR}/javadoc/pki
    SUBPACKAGES
        com.netscape.cmsutil
        com.netscape.certsrv
        com.netscape.cmstools
        org.dogtagpki
        ${PKI_JAVADOC_SUBPACKAGES}
    CLASSPATH
        ${SLF4J_API_JAR} ${JAXB_API_JAR}
        ${XALAN_JAR} ${XERCES_JAR}
        ${COMMONS_CLI_JAR} ${COMMONS_LANG3_JAR}
        ${COMMONS_CODEC_JAR} ${COMMONS_IO_JAR}
        ${LDAPJDK_JAR}
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR}
        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
        ${JAXRS_API_JAR} ${JACKSON2_CORE_JAR}
        ${JACKSON2_ANNOTATIONS_JAR} ${JACKSON2_DATABIND_JAR} ${JACKSON2_JAXB_ANNOTATIONS_JAR}
        ${RESTEASY_JAXRS_JAR} ${RESTEASY_CLIENT_JAR}
        ${JSS_JAR} ${SYMKEY_JAR} ${TOMCATJSS_JAR}
        ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_TOOLS_JAR}
        ${PKI_JAVADOC_CLASSPATH}
    OPTIONS
        -windowtitle 'pki-javadoc'
        -doctitle '<h1>PKI Javadoc</h1>'
        -author
        -use
        -version
        -quiet
        ${doclintstr}
    DEPENDS
        pki-cmsutil-jar pki-certsrv-jar pki-tools-jar
        ${PKI_JAVADOC_DEPENDS}
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/javadoc/pki
    DESTINATION
        ${CMAKE_INSTALL_PREFIX}/share/javadoc
)

=== base/server/CMakeLists.txt ===
project(server)

add_subdirectory(cmsbundle)
add_subdirectory(healthcheck)

# build server classes
javac(pki-server-classes
    DEPENDS
        pki-cmsutil-jar pki-certsrv-jar pki-tools-jar pki-tomcat-jar
    SOURCES
        src/main/java/*.java
    CLASSPATH
        ${SLF4J_API_JAR} ${JAXB_API_JAR}
        ${COMMONS_CODEC_JAR} ${COMMONS_IO_JAR} ${COMMONS_LANG3_JAR}
        ${COMMONS_CLI_JAR}
        ${HTTPCORE_JAR} ${HTTPCLIENT_JAR}
        ${JACKSON2_ANNOTATIONS_JAR} ${JACKSON2_JAXB_ANNOTATIONS_JAR}
        ${JACKSON2_CORE_JAR} ${JACKSON2_DATABIND_JAR}
        ${JSS_JAR} ${SYMKEY_JAR}
        ${LDAPJDK_JAR}
        ${XALAN_JAR} ${XERCES_JAR}
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR}
        ${TOMCATJSS_JAR}
        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR}
        ${PKI_CMSUTIL_JAR} ${PKI_TOMCAT_JAR} ${PKI_CERTSRV_JAR}
    OUTPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/main/resources/META-INF/MANIFEST.MF
    ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST.MF
)

# build pki-cms.jar
jar(pki-cms-jar
    DEPENDS
        pki-server-classes
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-cms.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST.MF
    INPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
)

set(PKI_CMS_JAR ${CMAKE_BINARY_DIR}/dist/pki-cms.jar CACHE INTERNAL "pki-cms jar file")

if(WITH_TEST)
    # build pki-server-test
    javac(pki-server-test-classes
        DEPENDS
            pki-util-test-classes pki-cmsutil-jar pki-certsrv-jar pki-cms-jar pki-cmsbundle-jar
        SOURCES
            src/test/java/*.java
        CLASSPATH
            ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_CMS_JAR} ${PKI_CMSBUNDLE_JAR}
            ${LDAPJDK_JAR} ${SERVLET_JAR} ${XALAN_JAR} ${XERCES_JAR}
            ${JSS_JAR} ${COMMONS_CODEC_JAR} ${SYMKEY_JAR}
            ${HAMCREST_JAR} ${JUNIT_JAR} ${COMMONS_IO_JAR}
            ${JACKSON2_ANNOTATIONS_JAR} ${JACKSON2_CORE_JAR} ${JACKSON2_DATABIND_JAR}
            ${CMAKE_BINARY_DIR}/test/classes
        OUTPUT_DIR
            ${CMAKE_BINARY_DIR}/test/classes
    )

    # create test target
    # do not include xalan and xerces in class path
    # TODO: create CMake function to find all JUnit test classes
    add_junit_test(test-pki-server
        DEPENDS
            pki-server-test-classes
        CLASSPATH
            ${SLF4J_API_JAR} ${SLF4J_SIMPLE_JAR}
            ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_CMS_JAR} ${PKI_CMSBUNDLE_JAR}
            ${LDAPJDK_JAR} ${SERVLET_JAR}
            ${COMMONS_CODEC_JAR} ${COMMONS_LANG3_JAR}
            ${JSS_JAR} ${SYMKEY_JAR}
            ${JACKSON2_ANNOTATIONS_JAR} ${JACKSON2_CORE_JAR} ${JACKSON2_DATABIND_JAR}
            ${HAMCREST_JAR} ${JUNIT_JAR} ${COMMONS_IO_JAR}
            ${CMAKE_BINARY_DIR}/test/classes
        TESTS
            com.netscape.cmscore.authentication.AuthTokenTest
            com.netscape.cmscore.dbs.CertRecordListTest
            com.netscape.cmscore.dbs.DBRegistryTest
            com.netscape.cmscore.request.AgentApprovalsTest
            com.netscape.cmscore.request.ExtAttrDynMapperTest
            com.netscape.cmscore.request.ExtDataHashtableTest
            com.netscape.cmscore.request.RequestQueueTest
            com.netscape.cmscore.request.RequestRecordTest
            com.netscape.cmscore.request.RequestTest
            com.netscape.cmscore.password.PlainPasswordFileTest
        REPORTS_DIR
            reports
    )
endif(WITH_TEST)

# Create /usr/share/pki/server/lib. This can be customized for different platforms in RPM spec.

add_custom_target(pki-server-lib ALL
    COMMENT "Creating links for PKI server library")

add_custom_command(
    TARGET pki-server-lib
    COMMAND ${CMAKE_COMMAND} -E make_directory lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} lib/slf4j-jdk14.jar
)

# Create /usr/share/pki/server/common/lib. This can be customized for different platforms in RPM spec.

add_custom_target(pki-server-common-lib ALL
    COMMENT "Creating links for PKI server common library")

add_custom_command(
    TARGET pki-server-common-lib
    COMMAND ${CMAKE_COMMAND} -E make_directory common/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_CODEC_JAR} common/lib/commons-codec.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_IO_JAR} common/lib/commons-io.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_LANG3_JAR} common/lib/commons-lang3.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_LOGGING_JAR} common/lib/commons-logging.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${HTTPCLIENT_JAR} common/lib/httpclient.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${HTTPCORE_JAR} common/lib/httpcore.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON2_CORE_JAR} common/lib/jackson-core.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON2_DATABIND_JAR} common/lib/jackson-databind.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON2_ANNOTATIONS_JAR} common/lib/jackson-annotations.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON2_JAXRS_BASE_JAR} common/lib/jackson-jaxrs-base.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON2_JAXRS_JSON_PROVIDER_JAR} common/lib/jackson-jaxrs-json-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON2_JAXB_ANNOTATIONS_JAR} common/lib/jackson-module-jaxb-annotations.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JSS_JAR} common/lib/jss.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${LDAPJDK_JAR} common/lib/ldapjdk.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsutil.jar ${CMAKE_CURRENT_BINARY_DIR}/common/lib/pki-cmsutil.jar
    COMMAND ln -sf /usr/share/java/pki/pki-tomcat.jar ${CMAKE_CURRENT_BINARY_DIR}/common/lib/pki-tomcat.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_CLIENT_JAR} common/lib/resteasy-client.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-jackson2-provider.jar common/lib/resteasy-jackson2-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JAXRS_API_JAR} common/lib/jaxrs-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_JAXRS_JAR} common/lib/resteasy-jaxrs.jar
    COMMAND ln -sf /usr/lib/java/symkey.jar ${CMAKE_CURRENT_BINARY_DIR}/common/lib/symkey.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${TOMCATJSS_JAR} common/lib/tomcatjss.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${XERCES_JAR} common/lib/xerces-j2.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${XML_COMMONS_RESOLVER_JAR} common/lib/xml-commons-resolver.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_NET_JAR} common/lib/commons-net.jar
)

if(JAVA_VERSION GREATER 10)
    add_custom_target(pki-server-java11plus-lib ALL
        DEPENDS pki-server-common-lib
        COMMENT "Creating links for server library required in Java 11+")

    add_custom_command(
        TARGET pki-server-java11plus-lib
        COMMAND ${CMAKE_COMMAND} -E create_symlink ${JAXB_API_JAR} common/lib/jaxb-api.jar
        COMMAND ${CMAKE_COMMAND} -E create_symlink ${JAKARTA_ACTIVATION_JAR} common/lib/jakarta.activation.jar
    )
endif(JAVA_VERSION GREATER 10)

# Create /usr/share/pki/server/webapps/pki/WEB-INF/lib. This can be customized for different platforms in RPM spec.

add_custom_target(pki-server-webapp-lib ALL
    COMMENT "Creating links for PKI webapp library")

add_custom_command(
    TARGET pki-server-webapp-lib
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
)

add_custom_target(pki-server-man ALL
    COMMENT "Creating PKI server manuals")

add_custom_command(
    TARGET pki-server-man
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/man/man1
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man1/pkidaemon.1.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man1/pkidaemon.1
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/man/man5
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man5/pki_default.cfg.5.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man5/pki_default.cfg.5
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man5/pki-server-logging.5.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man5/pki-server-logging.5
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man5/pki_healthcheck.conf.5.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man5/pki_healthcheck.conf.5
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/man/man8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-acme.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-acme.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-ca.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-ca.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-cert.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-cert.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-instance.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-instance.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-kra.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-kra.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-migrate.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-migrate.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-nuxwdog.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-nuxwdog.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-ocsp.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-ocsp.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-subsystem.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-subsystem.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-tks.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-tks.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-tps.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-tps.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-server-upgrade.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-server-upgrade.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pkidestroy.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pkidestroy.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pkispawn.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pkispawn.8
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man8/pki-healthcheck.8.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man8/pki-healthcheck.8
)

# Customize default tomcat.conf.
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/share/etc/tomcat.conf
    ${CMAKE_CURRENT_BINARY_DIR}/share/etc/tomcat.conf
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-cms.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

install(
    DIRECTORY
        certs/
    DESTINATION
        ${DATA_INSTALL_DIR}/server/certs
)

install(
    DIRECTORY
        examples/
    DESTINATION
        ${DATA_INSTALL_DIR}/server/examples
)

install(
    FILES
         ${CMAKE_CURRENT_BINARY_DIR}/share/etc/tomcat.conf
    DESTINATION

=== base/tks/CMakeLists.txt ===
project(tks NONE)

add_subdirectory(setup)
add_subdirectory(shared/conf)
add_subdirectory(${APP_SERVER})

# build pki-tks
javac(pki-tks-classes
    DEPENDS
        symkey-jar pki-cmsutil-jar pki-certsrv-jar pki-cms-jar
    SOURCES
        src/main/java/*.java
    CLASSPATH
        ${JAXB_API_JAR}
        ${SLF4J_API_JAR}
        ${COMMONS_CLI_JAR}
        ${COMMONS_CODEC_JAR}
        ${COMMONS_LANG3_JAR}
        ${JACKSON2_ANNOTATIONS_JAR}
        ${LDAPJDK_JAR}
        ${JSS_JAR} ${SYMKEY_JAR}
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR}
        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR}
        ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_CMS_JAR}
    OUTPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/main/resources/META-INF/MANIFEST.MF
    ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST.MF
)

jar(pki-tks-jar
    DEPENDS
        pki-tks-classes
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-tks.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST.MF
    INPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
)

# Create links at /usr/share/pki/tks/webapps/tks/admin/console.
# Create /usr/share/pki/tks/webapps/tks/WEB-INF/lib.
# This can be customized for different platforms in RPM spec.

add_custom_target(pki-tks-links ALL
    COMMENT "Creating links for TKS")

add_custom_command(
    TARGET pki-tks-links
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/admin
    COMMAND ln -sf ${DATA_INSTALL_DIR}/server/webapps/pki/admin/console ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
    COMMAND ln -sf /usr/share/java/pki/pki-tks.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-tks.jar
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-tks.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

set(PKI_TKS_JAR ${CMAKE_BINARY_DIR}/dist/pki-tks.jar CACHE INTERNAL "pki-tks jar file")

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin/
    DESTINATION
        ${DATA_INSTALL_DIR}/tks/webapps/tks/admin
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/tks/webapps/tks/WEB-INF/lib
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/tks
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/tks
)

=== base/tps/CMakeLists.txt ===
project(tps Java)

# install files
add_subdirectory(setup)
add_subdirectory(shared/conf)
add_subdirectory(${APP_SERVER})

# build pki-tps
javac(pki-tps-classes
    DEPENDS
        symkey-jar pki-cmsutil-jar pki-certsrv-jar pki-cms-jar
    SOURCES
        src/main/java/*.java
    CLASSPATH
        ${JAXB_API_JAR}
        ${SLF4J_API_JAR}
        ${COMMONS_CLI_JAR}
        ${COMMONS_CODEC_JAR}
        ${COMMONS_LANG3_JAR}
        ${JACKSON2_ANNOTATIONS_JAR}
        ${LDAPJDK_JAR}
        ${JSS_JAR} ${SYMKEY_JAR}
        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR}
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR}
        ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_CMS_JAR}
    OUTPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/main/resources/META-INF/MANIFEST.MF
    ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST.MF
)

jar(pki-tps-jar
    DEPENDS
        pki-tps-classes
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-tps.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST.MF
    INPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
)

# TPS does not support admin console.
# Create links in /usr/share/pki/tps/webapps/tps/WEB-INF/lib.
# This can be customized for different platforms in RPM spec.

add_custom_target(pki-tps-links ALL
    COMMENT "Creating links for TPS")

add_custom_command(
    TARGET pki-tps-links
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
    COMMAND ln -sf /usr/share/java/pki/pki-tps.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-tps.jar
)

add_custom_target(pki-tps-man ALL
    COMMENT "Creating TPS manuals")

add_custom_command(
    TARGET pki-tps-man
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/man/man5
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man5/pki-tps-connector.5.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man5/pki-tps-connector.5
    COMMAND go-md2man -in ${CMAKE_SOURCE_DIR}/docs/manuals/man5/pki-tps-profile.5.md -out ${CMAKE_CURRENT_BINARY_DIR}/man/man5/pki-tps-profile.5
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-tps.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

set(PKI_TPS_JAR ${CMAKE_BINARY_DIR}/dist/pki-tps.jar CACHE INTERNAL "pki-tps jar file")

# install directories
install(
    DIRECTORY
        auth/
    DESTINATION
        ${DATA_INSTALL_DIR}/tps/auth/
)

install(
    DIRECTORY
        bin/
    DESTINATION
        ${DATA_INSTALL_DIR}/tps/bin
    FILE_PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
)

install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
    PATTERN
        listappletdates EXCLUDE
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/tps/webapps/tps/WEB-INF/lib
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/tps
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/tps
)

# install man pages generated by md2man
install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/man/
    DESTINATION
        ${MAN_INSTALL_DIR}
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ
        WORLD_READ
)

=== base/util/CMakeLists.txt ===
project(util NONE)

javac(pki-cmsutil-classes
    SOURCES
        src/main/java/*.java
    CLASSPATH
        ${COMMONS_LANG3_JAR} ${HTTPCORE_JAR} ${HTTPCLIENT_JAR}
        ${LDAPJDK_JAR} ${XALAN_JAR} ${XERCES_JAR}
        ${JSS_JAR} ${COMMONS_CODEC_JAR} ${JAXB_API_JAR}
        ${JACKSON2_JAXB_ANNOTATIONS_JAR} ${JACKSON2_CORE_JAR} ${JACKSON2_DATABIND_JAR}
        ${SLF4J_API_JAR}
    OUTPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
    DEPENDS
        symkey-jar
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/main/resources/META-INF/MANIFEST.MF
    ${CMAKE_CURRENT_BINARY_DIR}/src/main/resources/META-INF/MANIFEST.MF
)

jar(pki-cmsutil-jar
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-cmsutil.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/src/main/resources/META-INF/MANIFEST.MF
    INPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
    FILES
        *.class
    DEPENDS
        pki-cmsutil-classes
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/dist/pki-cmsutil.jar
    DESTINATION
        ${JAVA_JAR_INSTALL_DIR}/pki
)

set(PKI_CMSUTIL_JAR ${CMAKE_BINARY_DIR}/dist/pki-cmsutil.jar CACHE INTERNAL "pki-cmsutil jar file")

if(WITH_TEST)
    javac(pki-util-test-classes
        SOURCES
            src/test/java/*.java
        CLASSPATH
            ${PKI_CMSUTIL_JAR}
            ${JSS_JAR} ${LDAPJDK_JAR} ${COMMONS_CODEC_JAR} ${XALAN_JAR} ${XERCES_JAR}
            ${JACKSON2_JAXB_ANNOTATIONS_JAR} ${JACKSON2_CORE_JAR} ${JACKSON2_DATABIND_JAR}
            ${HAMCREST_JAR} ${JUNIT_JAR}
        OUTPUT_DIR
            ${CMAKE_BINARY_DIR}/test/classes
        DEPENDS
            pki-cmsutil-jar
    )

    # TODO: create CMake function to find all JUnit test classes
    add_junit_test(test-pki-util
        CLASSPATH
            ${SLF4J_API_JAR} ${SLF4J_JDK14_JAR}
            ${PKI_CMSUTIL_JAR}
            ${JSS_JAR} ${LDAPJDK_JAR} ${COMMONS_CODEC_JAR}
            ${JACKSON2_JAXB_ANNOTATIONS_JAR} ${JACKSON2_CORE_JAR} ${JACKSON2_DATABIND_JAR}
            ${HAMCREST_JAR} ${JUNIT_JAR}
            ${CMAKE_BINARY_DIR}/test/classes
        TESTS
            com.netscape.cmsutil.crypto.KeyIDCodecTest
        REPORTS_DIR
            reports
        DEPENDS
            pki-util-test-classes
    )
endif(WITH_TEST)

install(
    FILES
        src/main/shell/PKICertImport.bash
    DESTINATION
        ${BIN_INSTALL_DIR}
    RENAME
        PKICertImport
    PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
)

=== themes/dogtag/CMakeLists.txt ===
project(dogtag)

# compute certificate system name
set(CERTIFICATE_SYSTEM_THEME "Dogtag")
if ("${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}" STREQUAL "10.5")
    set(CERTIFICATE_SYSTEM_VERSION "9")
elseif ("${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}" STREQUAL "10.6")
    set(CERTIFICATE_SYSTEM_VERSION "10")
else()
    set(CERTIFICATE_SYSTEM_VERSION "")
endif()
set(CERTIFICATE_SYSTEM_NAME "${CERTIFICATE_SYSTEM_THEME} Certificate System ${CERTIFICATE_SYSTEM_VERSION}")

add_subdirectory(common-ui)

if (BUILD_PKI_CONSOLE)
    add_subdirectory(console-ui)
endif (BUILD_PKI_CONSOLE)

=== base/tools/src/main/native/p12tool/CMakeLists.txt ===
project(p12tool C)

set(P12TOOL_PRIVATE_INCLUDE_DIRS
  ${CMAKE_BINARY_DIR}
  ${NSPR_INCLUDE_DIRS}
  ${NSS_INCLUDE_DIRS}
)

set(P12TOOL_LINK_LIBRARIES
  ${NSPR_LIBRARIES}
  ${NSS_LIBRARIES}
)

set(p12tool_SRCS
    basicutil.c
    pppolicy.c
    secutil.c
    secpwd.c
    moreoids.c
    p12tool.c
)

include_directories(${P12TOOL_PRIVATE_INCLUDE_DIRS})

add_executable(p12tool ${p12tool_SRCS})
add_dependencies(p12tool pki-certsrv-jar)
target_link_libraries(p12tool ${P12TOOL_LINK_LIBRARIES})

install(
    TARGETS p12tool
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

=== debian/changelog ===
dogtag-pki (11.0.0-1) unstable; urgency=medium

  * New upstream release
    - CVE-2020-25715 (Closes: #988153)
  * dont-install-deleted-files.diff: Dropped, obsolete.
  * patches: Refreshed.
  * rules: Bump tomcat source path.
  * add-freebl-headers.diff: Add headers that libnss3-dev doesn't ship.
  * pki-tools: Add p12tool.
  * tests: Add --debug to pkispawn/pkidestroy.
  * Update service files.
  * control: Drop python3-pytest-runner from build-deps, not used anymore.
  * use-resteasy-legacy.diff: Dropped, obsolete and not applied anyway.
  * control: Drop unused libcommons-collections3-java from server depends.
  * fix-tomcat-paths.diff: Add catalina.properties and pki.policy to list of files to fix.
  * fix-symkey-path.diff: Refreshed.
  * control: Bump depends on libjss-java, libldap-java, libtomcatjss-java, libidm-console-framework-java.
  * install: Fix javadoc install.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 19 Oct 2021 18:25:25 +0300

dogtag-pki (10.10.6-1) unstable; urgency=medium

  * New upstream release. (Closes: #993534)
    - CVE-2021-3551 (Closes: #991665)
  * CVE-2021-20179.diff: Dropped, upstream.
  * Refresh patches.
  * JNA requirement got dropped, update packaging for it.
  * pki-server.postinst: Remove world access from existing installation
    logs.
  * control: Drop velocity from depends, it's not used anymore.
  * control: Drop libcommons-httpclient-java from depends, not used
    anymore.
  * control: Bump libjss dependency.
  * pki-tps.install: Updated.
  * tests: Add iproute2 to test depends. (Closes: #991173)
  * tests: Add isolation-container to test restrictions. (Closes:
    #991174)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 07 Sep 2021 14:25:32 +0300

=== debian/control ===
Source: dogtag-pki
Section: java
Priority: optional
Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@alioth-lists.debian.net>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends:
 apache2-dev,
 cmake,
 debhelper-compat (= 12),
 default-jdk,
 dh-python,
 go-md2man,
 javahelper,
 junit4,
 libactivation-java,
 libcommons-cli-java,
 libcommons-codec-java,
 libcommons-io-java,
 libcommons-lang3-java,
 libcommons-net-java,
 libhttpclient-java,
 libhttpcore-java,
 libidm-console-framework-java (>= 2.0.0),
 libjackson2-annotations-java,
 libjackson2-core-java,
 libjackson2-databind-java,
 libjaxb-java,
 libjaxp1.3-java,
 libjss-java (>= 5.0.0),
 libldap-java (>= 5.0.0),
 libldap2-dev,
 libnspr4-dev,
 libnss3-dev,
 libresteasy3.0-java (>= 3.0.19-5),
 libslf4j-java,
 libtomcat9-java,
 libtomcatjss-java (>= 8.0.0),
 libxalan2-java,
 libxerces2-java,
 libxml-commons-external-java,
 pkg-config,
 policycoreutils,
 python3-cryptography,
 python3-dev,
 python3-distutils,
 python3-ldap,
 python3-nss,
 python3-requests,
 python3-setuptools,
 python3-sphinx,
 python3-urllib3,
 zlib1g-dev,
 389-ds-base-dev (>= 1.4.0.16-1),
Standards-Version: 4.5.0
Homepage: http://pki.fedoraproject.org
Vcs-Git: https://salsa.debian.org/freeipa-team/dogtag-pki.git
Vcs-Browser: https://salsa.debian.org/freeipa-team/dogtag-pki

Package: dogtag-pki
Architecture: all
Depends:
 dogtag-pki-console-theme,
 dogtag-pki-server-theme,
 pki-base,
 pki-ca,
 pki-console,
 pki-javadoc,
 pki-kra,
 pki-ocsp,
 pki-server,
 pki-tks,
 pki-tools,
 pki-tps,
 ${misc:Depends},
Description: Dogtag Public Key Infrastructure (PKI) Suite
 The Dogtag Public Key Infrastructure (PKI) Suite is comprised of the following
 five subsystems and a client (for use by a Token Management System):
 .
   * Certificate Authority (CA)
   * Data Recovery Manager (DRM)
   * Online Certificate Status Protocol (OCSP) Manager
   * Token Key Service (TKS)
   * Token Processing System (TPS)
   * Enterprise Security Client (ESC)
 .
 Additionally, it provides a console GUI application used for server and
 user/group administration of CA, DRM, OCSP, and TKS, javadocs on portions
 of the Dogtag API, as well as various command-line tools used to assist with
 a PKI deployment.
 .
 This metapackage installs every PKI subsystem.

Package: pki-base
Architecture: all
Depends:
 python3-pki-base,
 ${misc:Depends},
 ${python3:Depends},
Description: Certificate System - PKI Framework
 The PKI Framework contains the common and client libraries and utilities.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-base-java
Architecture: all
Replaces: pki-base (<< 10.3.5-1)
Breaks: pki-base (<< 10.3.5-1)
Depends:
 libcommons-cli-java,
 libcommons-codec-java,
 libcommons-io-java,
 libcommons-lang3-java,
 libcommons-logging-java,
 libcommons-net-java,
 libhttpclient-java,
 libhttpcore-java,
 libjaxp1.3-java,
 libjettison-java,
 libjss-java (>= 5.0.0),
 libldap-java (>= 5.0.0),
 libresteasy3.0-java (>= 3.0.19-5),
 libslf4j-java,
 libstax-java,
 libxalan2-java,
 libxerces2-java,
 libxml-commons-external-java,
 libxml-commons-resolver1.1-java,
 openjdk-11-jre-headless,
 pki-base (= ${binary:Version}),
 ${java:Depends},
 ${misc:Depends},
Suggests:
 pki-tools,
Description: Certificate System - PKI Framework -- java client support
 The PKI Framework contains the common and client libraries and utilities.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: python3-pki-base
Architecture: all
Depends:
 openssl,
 python3-cryptography,
 python3-ldap,
 python3-nss,
 python3-requests,
 python3-urllib3,
 ${misc:Depends},
 ${python3:Depends},
Description:  Certificate System - PKI Framework -- python3 client support
 The PKI Framework contains the common and client libraries and utilities.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-tools
Architecture: any
Depends:
 ldap-utils,
 libjackson2-annotations-java,
 libnss3-tools,
 openssl,
 p11-kit-modules,
 pki-base-java (= ${source:Version}),
 python3-pki-base (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Conflicts: strongswan-starter, strongswan-pki,
Replaces: pki-base-java (<< 10.10.2-3)
Breaks: pki-base-java (<< 10.10.2-3)
Description: Certificate System - PKI Tools
 This package contains PKI executables that can be used to help make
 Certificate System into a more complete and robust PKI solution.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-server
Architecture: any
Depends:
 adduser,
 dogtag-pki-server-theme (>= ${source:Version}),
 keyutils,
 ldap-utils,
 libactivation-java,
 libatk-wrapper-java,
 libcommons-dbcp-java,
 libcommons-pool-java,
 libgeronimo-annotation-1.3-spec-java,
 libjackson-json-java,
 libjackson2-annotations-java,
 libjackson2-jaxrs-providers-java,
 libjaxb-java,
 libjboss-logging-java,
 libjs-jquery,
 libjs-underscore,
 libsymkey-java (= ${source:Version}),
 libtomcatjss-java (>= 8.0.0),
 libxml-commons-external-java,
 libxml-commons-resolver1.1-java,
 openssl,
 pki-base (= ${source:Version}),
 pki-base-java (= ${source:Version}),
 pki-tools (= ${binary:Version}),
 python3-cryptography,
 python3-ipahealthcheck-core,
 python3-ldap,
 python3-lxml,
 python3-selinux,
 tomcat9-user,
 ${java:Depends},
 ${misc:Depends},
 ${python3:Depends},
Conflicts: libtomcat7-java
Description: Certificate System - PKI Server Framework
 The PKI Server Framework is required by the following four PKI subsystems:
 .
     the Certificate Authority (CA),
     the Data Recovery Manager (DRM),
     the Online Certificate Status Protocol (OCSP) Manager, and
     the Token Key Service (TKS).
 .
 This package is a part of the PKI Core used by the Certificate System.
 The package contains scripts to create and remove PKI subsystems.

Package: pki-ca
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: 389-ds-base
Description: Certificate System - Certificate Authority
 The Certificate Authority (CA) is a required PKI subsystem which issues,
 renews, revokes, and publishes certificates as well as compiling and
 publishing Certificate Revocation Lists (CRLs).
 .
 The Certificate Authority can be configured as a self-signing Certificate
 Authority, where it is the root CA, or it can act as a subordinate CA,
 where it obtains its own signing certificate from a public CA.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: dogtag-pki-console-theme
Architecture: all
Section: web
Depends: ${java:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Certificate System - PKI Console User Interface
 This PKI Console User Interface contains the Dogtag textual
 and graphical user interface for the PKI Console.
 .
 This package is used by the Dogtag Certificate System.

Package: dogtag-pki-server-theme
Architecture: all
Section: web
Depends: ${java:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Certificate System - PKI Server User Interface
 This PKI Common Framework User Interface contains the Dogtag
 textual and graphical user interface for the PKI Common Framework.
 .
 This package is used by the Dogtag Certificate System.

Package: pki-console
Architecture: all
Depends:
 dogtag-pki-console-theme,
 libidm-console-framework-java (>= 2.0.0),
 libjss-java,
 libldap-java,
 pki-base (>= 10.0),
 ${java:Depends},
 ${misc:Depends},
Description: Certificate System - PKI Console
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The PKI Console is a java application used to administer CS.

Package: pki-kra
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: pki-ca
Description: Certificate System - Data Recovery Manager
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Data Recovery Manager (DRM) is an optional PKI subsystem that can act
 as a Key Recovery Authority (KRA).  When configured in conjunction with the
 Certificate Authority (CA), the DRM stores private encryption keys as part of
 the certificate enrollment process.  The key archival mechanism is triggered
 when a user enrolls in the PKI and creates the certificate request.  Using the
 Certificate Request Message Format (CRMF) request format, a request is
 generated for the user's private encryption key.  This key is then stored in
 the DRM which is configured to store keys in an encrypted format that can only
 be decrypted by several agents requesting the key at one time, providing for
 protection of the public encryption keys for the users in the PKI deployment.
 .
 Note that the DRM archives encryption keys; it does NOT archive signing keys,
 since such archival would undermine non-repudiation properties of signing keys.

Package: pki-ocsp
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: pki-ca
Description: Certificate System - Online Certificate Status Protocol Manager
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Online Certificate Status Protocol (OCSP) Manager is an optional PKI
 subsystem that can act as a stand-alone OCSP service.  The OCSP Manager
 performs the task of an online certificate validation authority by enabling
 OCSP-compliant clients to do real-time verification of certificates.  Note
 that an online certificate-validation authority is often referred to as an
 OCSP Responder.
 .
 Although the Certificate Authority (CA) is already configured with an
 internal OCSP service.  An external OCSP Responder is offered as a separate
 subsystem in case the user wants the OCSP service provided outside of a
 firewall while the CA resides inside of a firewall, or to take the load of
 requests off of the CA.
 .
 The OCSP Manager can receive Certificate Revocation Lists (CRLs) from
 multiple CA servers, and clients can query the OCSP Manager for the
 revocation status of certificates issued by all of these CA servers.
 .
 When an instance of OCSP Manager is set up with an instance of CA, and
 publishing is set up to this OCSP Manager, CRLs are published to it
 whenever they are issued or updated.

Package: pki-tks
Architecture: all
Depends:
 libsymkey-java (>= ${source:Version}),
 pki-server (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
Suggests: pki-ca
Description: Certificate System - Token Key Service
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Token Key Service (TKS) is an optional PKI subsystem that manages the
 master key(s) and the transport key(s) required to generate and distribute
 keys for hardware tokens.  TKS provides the security between tokens and an
 instance of Token Processing System (TPS), where the security relies upon the
 relationship between the master key and the token keys.  A TPS communicates
 with a TKS over SSL using client authentication.
 .
 TKS helps establish a secure channel (signed and encrypted) between the token
 and the TPS, provides proof of presence of the security token during
 enrollment, and supports key changeover when the master key changes on the
 TKS.  Tokens with older keys will get new token keys.
 .
 Because of the sensitivity of the data that TKS manages, TKS should be set up
 behind the firewall with restricted access.

Package: pki-tps
Architecture: all
Depends:
 pki-server (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: pki-ca, pki-kra, pki-tks
Description: Certificate System - Token Processing System
 Certificate System (CS) is an enterprise software system designed

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# This has to be exported to make some magic below work.
export DH_OPTIONS

VER :=  $(shell dpkg-parsechangelog | sed -n 's/^Version: *\(.*\)-.*$$/\1/ p' | sed -e 's/~.*//')

JAVA_HOME=/usr/lib/jvm/java-11-openjdk-$(DEB_BUILD_ARCH)
PKI_JAVA_HOME=debian/tmp/usr/share/pki/java-home
PKI_JAVA_PATH=/usr/share/pki/java-home/bin/java
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS += -I/usr/include/nss $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS += -I/usr/include/nss -I/usr/include/apr-1.0 $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS += $(shell dpkg-buildflags --get LDFLAGS)
DEB_BUILD_DIR ?= $(CURDIR)/build

CONFIGS = core

STAMP_DIR = debian/stamp
STAMP = $(STAMP_DIR)/$(DEB_BUILD_GNU_TYPE)
BUILD_STAMPS = $(addprefix $(STAMP)-build-, $(CONFIGS))

confflags = 

confflags-core = \
	-DJAVA_HOME=$(JAVA_HOME) \
	-DPKI_JAVA_PATH=$(PKI_JAVA_PATH) \
	-DVERSION=$(VER) \
	-DSYSTEMD_LIB_INSTALL_DIR=/lib/systemd/system \
	-DVAR_INSTALL_DIR:PATH=/var \
	-DRESTEASY_LIB=/usr/share/java/ \
	-DP11_KIT_TRUST=/usr/lib/$(DEB_HOST_MULTIARCH)/pkcs11/p11-kit-trust.so \
	-DPKI_CERTSRV_JAR=$(DEB_BUILD_DIR)/core/dist/pki-certsrv.jar \
	-DPKI_CMS_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cms.jar \
	-DPKI_CMSBUNDLE_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmsbundle.jar \
	-DPKI_CMSUTIL_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmsutil.jar \
	-DNSS_DEFAULT_DB_TYPE=sql \
	-DBUILD_PKI_CORE:BOOL=ON \
	-DAPP_SERVER=tomcat-9.0 \
	-DBUILD_PKI_CONSOLE:BOOL=ON \
	-DTHEME=dogtag \
	-DWITH_TEST=OFF \

%:
	dh $@ --with javahelper,python3,apache2 --builddirectory=build/ \
		--buildsystem=pybuild

override_dh_auto_clean:
	rm -rf $(CURDIR)/build
	rm -f $(CURDIR)/base/common/python/pki/*.pyc
	rm -rf $(CURDIR)/tomcat
	rm -rf $(CURDIR)/.pybuild
	rm -rf $(CURDIR)/base/common/python/pki/__pycache__
	rm -rf $(CURDIR)/base/symkey/src/main/java/com/netscape/symkey/SessionKey.class

override_dh_auto_configure:

build-stamp: $(BUILD_STAMPS)
	>$@

$(STAMP)-build-%:
	mkdir -p $(DEB_BUILD_DIR)/$*
	cd $(DEB_BUILD_DIR)/$* && \
	cmake -DCMAKE_INSTALL_PREFIX=/usr \
		-DSYSCONF_INSTALL_DIR:PATH=/etc \
		-DVAR_INSTALL_DIR:PATH=/var \
		-DJAVA_LIB_INSTALL_DIR=/usr/share/java \
		$(confflags-$*) \
		../../
	cd $(DEB_BUILD_DIR)/$* && make VERBOSE=1 $(MAKE_FLAGS)

override_dh_auto_build: build-stamp

override_dh_auto_install:
	set -e; for config in $(CONFIGS); do \
		make -C $(DEB_BUILD_DIR)/$$config DESTDIR=$(CURDIR)/debian/tmp install; \
	done

	find $(CURDIR)/debian/tmp/usr/share/pki -name '*.cgi' -exec chmod 755 '{}' ';'
	find $(CURDIR)/debian/tmp/usr/share/pki -name '*.pl' -exec chmod 755 '{}' ';'
	find $(CURDIR)/debian/tmp/lib/systemd -exec chmod 644 '{}' ';'

	rm -f $(CURDIR)/debian/tmp/lib/systemd/pki-tomcatd@.service

override_dh_installinit:
	dh_installinit -ppki-server --name=pki-tomcatd --error-handler=invoke_failure

override_dh_installsystemd:
	dh_installsystemd -ppki-server --no-enable --name pki-tomcatd@
	dh_installsystemd -ppki-server --no-enable pki-tomcatd-nuxwdog@.service

override_dh_install:
	# we don't use these
	rm -rf $(CURDIR)/debian/tmp/etc/rc.d

	# tpsclient hasn't been ported to java yet
	rm -rf $(CURDIR)/debian/tmp/lib/systemd/system/pki-tpsd* \
		$(CURDIR)/debian/tmp/usr/lib/httpd/modules/mod_tps.so \
		$(CURDIR)/debian/tmp/usr/lib/httpd/modules/mod_tokendb.so \
		$(CURDIR)/debian/tmp/usr/lib/tps/libldapauth.so \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/cgi-bin \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/docroot \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/lib \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/scripts \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/samples

	# not needed since we don't ship any binary applets
	rm -rf $(CURDIR)/debian/tmp/usr/share/pki/tps/applets

	ln -sf /usr/share/java/jboss-logging.jar $(CURDIR)/debian/tmp/usr/share/pki/lib/jboss-logging.jar
	ln -sf /usr/share/java/jboss-logging.jar $(CURDIR)/debian/tmp/usr/share/pki/server/common/lib/jboss-logging.jar

	ln -sf /usr/share/java/geronimo-annotation-1.3-spec.jar $(CURDIR)/debian/tmp/usr/share/pki/lib/geronimo-annotation-1.3-spec.jar
	ln -sf /usr/share/java/geronimo-annotation-1.3-spec.jar $(CURDIR)/debian/tmp/usr/share/pki/server/common/lib/geronimo-annotation-1.3-spec.jar

	# use our own symlink to the arch-dependent java dir
	ln -sf $(JAVA_HOME) $(PKI_JAVA_HOME)
	sed -i 's/lib\/jvm\/java-11-openjdk.*/share\/pki\/java-home/' \
		debian/tmp/usr/share/pki/etc/pki.conf

	rm -f $(CURDIR)/debian/tmp/usr/share/pki/lib/resteasy-jaxrs-jandex.jar

	dh_install

	mkdir -p debian/pki-server/usr/share/pki
	cp debian/tomcat-start.sh debian/pki-server/usr/share/pki

override_dh_missing:
	dh_missing --fail-missing

get-orig-source: SOURCE=dogtag-pki
get-orig-source: UV=$(shell dpkg-parsechangelog|awk '/^Version:/ {print $$2}'|sed 's/-.*$$//')
get-orig-source:
	tar --transform 's,^,$(SOURCE)-$(UV)/,' \
		--exclude 'debian' --exclude-vcs \
		-cJf ../$(SOURCE)_$(UV).orig.tar.xz .

=== debian/tests/control ===
Tests: pkispawn
Depends:
 @,
 389-ds-base (>= 1.4.1.6-1),
 iproute2,
 procps,
 sudo,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,

=== debian/watch ===
version=4
opts="compression=xz,repack,uversionmangle=s/-/~/, \
  filenamemangle=s%(?:.*?)?v@ANY_VERSION@\.tar\.gz%dogtag-pki-$1.tar.xz%" \
  https://github.com/dogtagpki/pki/releases/ \
  (?:.*?/)?v@ANY_VERSION@\.tar\.gz
